<template>
	<button
		ref="btnRef"
		@click="click"
		@mousedown="start"
		@mouseup="stop"
		@touchstart="start"
		@touchend="stop"
		@touchcancel="stop"
		:disabled="disabled"
	>
		<slot></slot>
	</button>
</template>

<script lang="ts" setup>
import { Ref, ref, watchEffect } from 'vue-demi';
import { useEventListener } from '../../hooks/useEventListener';

interface Data {
	started: boolean;
	oTimeout: number | null;
	oInterval: number | null;

}

const props = defineProps({
	interval: {
		type: Number,
		default: 30
	},
	delay: {
		type: Number,
		default: 300
	},
	disabled: {
		type: Boolean,
		default: false
	}
});

const emit = defineEmits(['click', 'hold']);
const btnRef = ref<HTMLButtonElement | null>(null);

const mouseup = useEventListener(btnRef, "mouseup", stop);
const mouseleave = useEventListener(btnRef, "mouseleave", stop);

const data: Data = {
	started: false,
	oTimeout: null,
	oInterval: null,
};

watchEffect(() => {
	stop();
})

function click(...args: any[]) {
	emit('click', ...args);
}
function start() {
	if (!data.started) {
		data.started = true;
		mouseup.add()
		mouseleave.add();
		data.oTimeout = window.setTimeout(() => {
			data.oInterval = window.setInterval(() => {
				emit("hold");
			}, props.interval);
		}, props.delay);
	}
}
function stop() {
	if (data.started) {
		if (data.oTimeout) {
			clearTimeout(data.oTimeout);
		}
		if (data.oInterval) {
			clearInterval(data.oInterval);
		}
		data.started = false;
		mouseup.remove();
		mouseleave.remove();
	}
}
</script>